=== debian/changelog ===
teakra (0.0~git20250117.4dfebf8-2) unstable; urgency=medium

  * d/*.install: s/x86_64-linux-gnu/*/ (Closes: #1102926)

 -- Andrea Pappacoda <tachi@debian.org>  Tue, 15 Apr 2025 18:48:33 +0200

teakra (0.0~git20250117.4dfebf8-1) unstable; urgency=low

  * Initial release. (Closes: #1093213)

 -- Andrea Pappacoda <tachi@debian.org>  Tue, 11 Mar 2025 23:02:27 +0100
