=== debian/watch ===
version=4
opts="mode=git, pretty=0.0~git%cd.%h, pgpmode=none" \
https://github.com/wwylele/teakra.git HEAD
