=== debian/changelog ===
teakra (0.0~git20250805.a66efb9-1) experimental; urgency=low

  * Update to new upstream version 0.0~git20250805.a66efb9.

 -- Andrea Pappacoda <andrea@pappacoda.it>  Wed, 06 Aug 2025 14:57:35 +0200
