=== debian/control ===
Source: teakra
Section: libs
Priority: optional
Maintainer: Andrea Pappacoda <tachi@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-build-api (= 1),
 cmake (>= 3.12),
 cmark <!nodoc>,
 libcatch2-dev,
 pkg-config,
Standards-Version: 4.7.2
Homepage: https://github.com/wwylele/teakra
Vcs-Git: https://salsa.debian.org/debian/teakra.git
Vcs-Browser: https://salsa.debian.org/debian/teakra
Description: DSi/3DS DSP emulator, (dis)assembler, and tester
 Teakra is an emulator, assembler, disassembler, and tester for XpertTeak, the
 DSP used by the DSi and 3DS game consoles.
X-Style: black

Package: libteakra0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package contains the shared library.

Package: libteakra-c0
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - C bindings
 ${source:Extended-Description}
 .
 This package contains the shared library of the C bindings.

Package: libteakra-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libteakra-c0 (= ${binary:Version}),
 libteakra0 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 teakra-doc,
Description: ${source:Synopsis} - development
 ${source:Extended-Description}
 .
 This package contains the development files.

Package: teakra-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package contains the documentation.
